package com.company.pbksb.entity.psb;

import com.haulmont.chile.core.annotations.MetaProperty;
import com.haulmont.chile.core.annotations.NamePattern;
import com.haulmont.cuba.core.entity.StandardEntity;

import javax.persistence.*;
import java.math.BigDecimal;

@Table(name = "PBKSB_GOOD")
@Entity(name = "pbksb_Good")
@NamePattern("%s|description")
public class Good extends StandardEntity {
    private static final long serialVersionUID = -722848079803749497L;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "GOOD_IN_ID")
    private Goods_IN good_in;

    @Column(name = "GOOD_TYPE")
    private String good_type;

    @Column(name = "CUSTOMS_CODE")
    private String customs_code;

    @Column(name = "CATEGORY_TYPE")
    private String category_type;

    @Column(name = "DESCRIPTION")
    private String description;

    @Column(name = "QUANTITY")
    private BigDecimal quantity;

    @Column(name = "VALUE_")
    private BigDecimal value;

    @Column(name = "UOM")
    private String uom;

    @Column(name = "LOCATION")
    private String location;

    public String getCustoms_code() {
        return customs_code;
    }

    public void setCustoms_code(String customs_code) {
        this.customs_code = customs_code;
    }

    public void setGood_type(Good_Type good_type) {
        this.good_type = good_type == null ? null : good_type.getId();
    }

    public Good_Type getGood_type() {
        return good_type == null ? null : Good_Type.fromId(good_type);
    }

    public Category_Type getCategory_type() {
        return category_type == null ? null : Category_Type.fromId(category_type);
    }

    public void setCategory_type(Category_Type category_type) {
        this.category_type = category_type == null ? null : category_type.getId();
    }

    public Location getLocation() {
        return location == null ? null : Location.fromId(location);
    }

    public void setLocation(Location location) {
        this.location = location == null ? null : location.getId();
    }

    public String getUom() {
        return uom;
    }

    public void setUom(String uom) {
        this.uom = uom;
    }

    public BigDecimal getValue() {
        return value;
    }

    public void setValue(BigDecimal value) {
        this.value = value;
    }

    public BigDecimal getQuantity() {
        return quantity;
    }

    public void setQuantity(BigDecimal quantity) {
        this.quantity = quantity;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Goods_IN getGood_in() {
        return good_in;
    }

    public void setGood_in(Goods_IN good_in) {
        this.good_in = good_in;
    }

    @MetaProperty(related = {"quantity", "value"})
    public BigDecimal getTotalValue(){
        return (quantity != null && value != null) ? quantity.multiply(value) : null;
    }
}