package com.company.pbksb.entity.psb;

import com.company.pbksb.entity.customer.Customer;
import com.haulmont.chile.core.annotations.NamePattern;
import com.haulmont.cuba.core.entity.StandardEntity;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

//@PublishEntityChangedEvents
//@Listeners("com.company.pbksb.listeners.Goods_INChangedListener")
@Table(name = "PBKSB_GOODS_IN")
@Entity(name = "pbksb_Goods_IN")
@NamePattern("%s %s|reference_no,registration_no")
public class Goods_IN extends StandardEntity {
    private static final long serialVersionUID = -197033953668687462L;

    @Column(name = "REFERENCE_NO")
    private String reference_no;

    @Column(name = "FORM_TYPE")
    private String form_type;

    @Column(name = "REGISTRATION_NO")
    private String registration_no;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "MOVE_DATE")
    private Date move_date;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "CUSTOMER_ID")
    private Customer customer;

    @Column(name = "AGENT_NAME")
    private String agent_name;

    @Column(name = "STORAGE")
    private String storage;

    @Column(name = "INVOICE_NO")
    private String invoice_no;

    @Column(name = "CATEGORY")
    private String category;

    @Column(name = "TOTAL_VALUE")
    private BigDecimal total_value;

    @Column(name = "STATUS")
    private String status;

    @Column(name = "REQUEST_BY")
    private String request_by;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "REQUEST_DATE")
    private Date request_date;

    @Column(name = "APPROVED_BY")
    private String approved_by;

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "APPROVED_DATE")
    private Date approved_date;

    public Date getApproved_date() {
        return approved_date;
    }

    public void setApproved_date(Date approved_date) {
        this.approved_date = approved_date;
    }

    public String getApproved_by() {
        return approved_by;
    }

    public void setApproved_by(String approved_by) {
        this.approved_by = approved_by;
    }

    public Date getRequest_date() {
        return request_date;
    }

    public void setRequest_date(Date request_date) {
        this.request_date = request_date;
    }

    public void setRequest_by(String request_by) {
        this.request_by = request_by;
    }

    public String getRequest_by() {
        return request_by;
    }

    public String getAgent_name() {
        return agent_name;
    }

    public void setAgent_name(String agent_name) {
        this.agent_name = agent_name;
    }

    public Good_In_Statu getStatus() {
        return status == null ? null : Good_In_Statu.fromId(status);
    }

    public void setStatus(Good_In_Statu status) {
        this.status = status == null ? null : status.getId();
    }

    public Customer getCustomer() {
        return customer;
    }

    public void setCustomer(Customer customer) {
        this.customer = customer;
    }

    public BigDecimal getTotal_value() {
        return total_value;
    }

    public void setTotal_value(BigDecimal total_value) {
        this.total_value = total_value;
    }

    public Good_Category getCategory() {
        return category == null ? null : Good_Category.fromId(category);
    }

    public void setCategory(Good_Category category) {
        this.category = category == null ? null : category.getId();
    }

    public String getInvoice_no() {
        return invoice_no;
    }

    public void setInvoice_no(String invoice_no) {
        this.invoice_no = invoice_no;
    }

    public Storage getStorage() {
        return storage == null ? null : Storage.fromId(storage);
    }

    public void setStorage(Storage storage) {
        this.storage = storage == null ? null : storage.getId();
    }

    public Date getMove_date() {
        return move_date;
    }

    public void setMove_date(Date move_date) {
        this.move_date = move_date;
    }

    public String getRegistration_no() {
        return registration_no;
    }

    public void setRegistration_no(String registration_no) {
        this.registration_no = registration_no;
    }

    public Form_Type getForm_type() {
        return form_type == null ? null : Form_Type.fromId(form_type);
    }

    public void setForm_type(Form_Type form_type) {
        this.form_type = form_type == null ? null : form_type.getId();
    }

    public String getReference_no() {
        return reference_no;
    }

    public void setReference_no(String reference_no) {
        this.reference_no = reference_no;
    }

}